package functional.graph.sameEdges;

class Graph {
	/*@ nullable @*/ EdgeList edges;
	/*@ nullable @*/ NodeList nodes;

	/*@ 
	 @ requires (\forall Node n; true; n.inEdges!=null && n.outEdges!=null);
	 @ requires (\forall Node n1, n2; n1 != n2; n1.nodeID != n2.nodeID);
	 @ requires (\forall Edge e1, e2; e1 != e2; e1.edgeID != e2.edgeID);
	 
	 @ requires (\forall NodeList l; true; l.count >= 0 && l.entries != null && l.count <= l.entries.length
	 			&& (\forall int i; i>=0 && i<l.count; l.entries[i] != null));
	
	 @ requires (\forall EdgeList l; true; l.count >= 0 && l.entries != null && l.count <= l.entries.length
	 			&& (\forall int i; i>=0 && i<l.count; l.entries[i] != null));
	 
	 @ requires edges != null && nodes != null && nl != null;
	 
     @ ensures \old(nl.count) == 0 ==> (\forall int i; 0<=i && i<edges.count; (\exists int j; 0<=j && j<\old(edges.count); edges.entries[i]==\old(edges.entries[j])));
	 @ diverges true;
	 @ assignable \everything;
	 @*/
	void wrapper(/*@ nullable @*/ NodeList nl) {
		remove(nl);
	}

	void remove(/*@ nullable @*/ NodeList nl) {
		// remove nodes
        impure();

		// remove outEdges and inEdges
		EdgeList el = edges;
		int j = 0;
		int nodesCount = this.nodes.count;
		/*@ maintaining 0<=j;
		  @ maintaining (\forall int k; 0<=k && k<edges.count; (\exists int l; 0<=l && l<\old(edges.count); edges.entries[k]==\old(edges.entries[l])));
		  @ assignable edges.entries, edges.count;
		  @*/
		while (j < nodesCount) {
			// remove outEdges and inEdges
			{
				Edge[] newEntries = new Edge[el.count];
				int lastI = 0;
				int oj = 0;
				int elCount = el.count;
				/*@		 
				 @ maintaining (\forall int a; 0<=a && a<lastI; (\exists int b; 0<=b && b<oj; newEntries[a] == el.entries[b]));
                 @ maintaining 0<=oj && oj<=el.count;
                 @ maintaining 0<=lastI && lastI<=oj;
				 @ assignable newEntries[*];
				 @*/
				while (oj < elCount) {
					Edge e = el.entries[oj];
					if ( b() ) { //					if (!containsE) {
						newEntries[lastI] = e;
						lastI = lastI + 1;
					}
					oj = oj + 1;
				}
				el.entries = newEntries;
				el.count = lastI;
			}

			j = j + 1;
		}
	}
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ b();
	/*@ assignable nodes.entries, nodes.count; @*/
	native boolean /*@ helper @*/ impure();
}
