package functional.graph.sameNodes;

class Graph {
	/*@ nullable @*/ EdgeList edges;
	/*@ nullable @*/ NodeList nodes;

	/*@ 
	 @ requires (\forall Node n; true; n.inEdges!=null && n.outEdges!=null);
	 @ requires (\forall Node n1, n2; n1 != n2; n1.nodeID != n2.nodeID);
	 @ requires (\forall Edge e1, e2; e1 != e2; e1.edgeID != e2.edgeID);
	 
	 @ requires (\forall NodeList l; true; l.count >= 0 && l.entries != null && l.count <= l.entries.length
	 			&& (\forall int i; i>=0 && i<l.count; l.entries[i] != null));
	
	 @ requires (\forall EdgeList l; true; l.count >= 0 && l.entries != null && l.count <= l.entries.length
	 			&& (\forall int i; i>=0 && i<l.count; l.entries[i] != null));
	 
	 @ requires edges != null && nodes != null && nl != null;
	 
	 @ ensures \old(nl.count) == 0 ==> (\forall int i; 0<=i && i<nodes.count; (\exists int j; 0<=j && j<\old(nodes.count); nodes.entries[i]==\old(nodes.entries[j]))); 
	 
	 @ diverges true;
	 @ assignable \everything;
	 @*/
	void wrapper(/*@ nullable @*/ NodeList nl) {
		remove(nl);
	}

	void remove(/*@ nullable @*/ NodeList nl) {
		// remove nodes
		{
			Node[] newEntries = new Node[nodes.count];

			int lastI = 0;
			int index = 0;
			int nodesCount = this.nodes.count;
            /*@
              @ maintaining (\forall int k; 0<=k && k<lastI; (\exists int l; 0<=l && l<index; newEntries[k] == nodes.entries[l]));
              @ maintaining 0<=lastI && lastI<=index;
              @ maintaining 0<=index && index<=nodesCount;
              @ 
              @ assignable newEntries[*], lastI;
              @*/
			while (index < nodesCount) {
				Node n = this.nodes.entries[index];
				if ( b() ) { //				if (!containsNode) {
					newEntries[lastI] = n;
					lastI = lastI + 1;
				}
				index = index + 1;
			}
			nodes.entries = newEntries;
			nodes.count = lastI;
		}

		// remove outEdges and inEdges
       impure(); 
	}
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ b();
	/*@ assignable edges.entries, edges.count; @*/
	native void /*@ helper @*/ impure();
}
