package functional.set.emptySet;

final class Set {
	/*@ nullable @*/int[] items;
	/*@ nullable @*/ Set res;

	/*@ 
	  @ requires this.items != null;
	  @ requires (\forall int i, j; 0<=i && i<this.items.length && 0<=j && j<this.items.length && i!=j; this.items[i] != this.items[j]);
	  @ requires 0 <= this.items.length;
	  @ requires p!=null && p.items != null;
	  @ requires (\forall int i, j; 0<=i && i<p.items.length && 0<=j && j<p.items.length && i!=j; p.items[i] != p.items[j]);
	  @ requires 0 <= p.items.length;
	  @ 
	  @ ensures (\old(this.items.length) == 0 || \old(p.items.length) == 0) ==> res.items.length == 0;
	  @ assignable \everything;
	  @ diverges true;
	  @*/
	void wrapper(/*@ nullable @*/ Set p) {
		intersect(p);
	}

	void intersect(/*@ nullable @*/ Set p) {
		res = new Set();
		res.items = new int[0];
		int len = this.items.length;
		int index = 0;
		/*@ loop_invariant 0 <= index && index <=len;		  
		  @ loop_invariant (len == 0 || p.items.length == 0) ==> res.items.length == 0;
		  @ assignable res.items;
		  @*/
		while (index < len) {
			int v = this.items[index];
			boolean found = false;
			int pLen = p.items.length;
			int pIndex = 0;
			/*@ loop_invariant (\forall int i; 0<=i && i<pIndex; this.items[i] != v);
			  @ loop_invariant 0<=pIndex && pIndex<=this.items.length;
			  @ assignable \strictly_nothing;
			  @*/
			while (pIndex < pLen) {
				if (p.items[pIndex] == v) {
					found = true;
					break;

				}
				pIndex = pIndex + 1;
			}

			if (found) {
				boolean resFound = false;
				int resLenF = res.items.length;
				int resIndexF = 0;
				/*@ loop_invariant (\forall int i; 0<=i && i<resIndexF; res.items[i] != v);
				  @ loop_invariant 0<=resIndexF && resIndexF<=res.items.length;
				  @ assignable \strictly_nothing;
				  @*/
				while (resIndexF < resLenF) {
					if (res.items[resIndexF] == v) {
						resFound = true;
						break;
					}
					resIndexF = resIndexF + 1;
				}

				if (!resFound) {
					int resLen = res.items.length;

					int[] newList = new int[resLen + 1];
					int resIndex = 0;
					/*@ loop_invariant (\forall int i; 0<=i && i<resIndex; newList[i] == res.items[i]);
					  @ loop_invariant newList.length == res.items.length + 1;
					  @ loop_invariant 0<=index && index <= res.items.length;
					  @ assignable newList[*];
					  @*/
					while (resIndex < resLen) {
						newList[resIndex] = res.items[resIndex];
						resIndex = resIndex + 1;
					}
					newList[resIndex] = v;
					res.items = newList;
				}
			}
			index = index + 1;
		}
	}
}
