package abstraction.dictionary.NegativeArraySizeException;

import abstraction.RuntimeException;

final class Dictionary {
	/*@ nullable @*/Key[] keys;
	/*@ nullable @*/Value[] values;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires keys != null && values != null;
	  @ requires (\forall int i,j; 0<=i && i<j && j<keys.length; keys[i] != keys[j]);
	  @ requires keys.length == values.length;
	  @ requires 0<=keys.length && keys.length<Integer.MAX_VALUE;
	  @ ensures !RuntimeException.NegativeArraySizeException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		put(k, v);
	}

	void put(/*@ nullable @*/ Key k, /*@ nullable @*/ Value v) {
		int pos = pure_int(); //		int pos = -1;
		pure_void();

		if ( pure_boolean() ) { //		if (pos >= 0) {
			this.values[pos] = pure_Value(); //			this.values[pos] = v;
		} else {
			Key[] oldKs = this.keys;
			int oldKLen = oldKs.length;
			if (oldKLen + 1 < 0) {
				RuntimeException.NegativeArraySizeException = true;
				return;
			}
			impure_keys();

			Value[] oldVs = this.values;
			int oldVLen = oldVs.length;
			if (oldVLen + 1 < 0) {
				RuntimeException.NegativeArraySizeException = true;
				return;
			}
			impure_values();
		}
	}
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ pure_int();
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ pure_boolean();

	/*@ assignable \strictly_nothing; @*/
	native void /*@ helper @*/ pure_void();
	/*@ assignable keys; @*/
	native void /*@ helper @*/ impure_keys();
	/*@ assignable values; @*/
	native void /*@ helper @*/ impure_values();
	/*@ assignable \strictly_nothing; @*/
	native Key /*@ helper @*/ pure_Key();
	/*@ assignable \strictly_nothing; @*/
	native Value /*@ helper @*/ pure_Value();
	
}
