package abstraction.set.NegativeArraySizeException;

import abstraction.RuntimeException;

final class Set {
	/*@ nullable @*/int[] items;
	/*@ nullable @*/ Set res;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires this.items != null;
	  @ requires (\forall int i, j; 0<=i && i<this.items.length && 0<=j && j<this.items.length && i!=j; this.items[i] != this.items[j]);
	  @ requires 0 <= this.items.length;
	  @ requires p!=null && p.items != null;
	  @ requires (\forall int i, j; 0<=i && i<p.items.length && 0<=j && j<p.items.length && i!=j; p.items[i] != p.items[j]);
	  @ requires 0 <= p.items.length;
	  @ ensures !RuntimeException.NegativeArraySizeException;
	  @ assignable \everything;
	  @ diverges true;
	  @*/
	void wrapper(/*@ nullable @*/ Set p){
		intersect(p);
	}

	void intersect(/*@ nullable @*/ Set p) {
		res = new Set();
		res.items = new int[0];
		int len = pure_int(); //		int len = this.items.length;
		int index = pure_int(); //		int index = 0;
		/*@ 
		  @ maintaining res.items.length >= 0; 
		  @ assignable res.items;
		  @*/
		while ( pure_boolean() ) { //		while (index < len) {
			pure_void();

			if ( pure_boolean() ) { //			if (found) {
				boolean resFound = pure_boolean(); //				boolean resFound = false;
				int resLenF = res.items.length;
				int resIndexF = 0;
				/*@ 
				  @ maintaining true;
				  @ assignable \strictly_nothing;
				 */
				while (resIndexF < resLenF) {
					if ( pure_boolean() ) { //					if (res.items[resIndexF] == v) {
						resFound = true;
						break;
					}
					resIndexF = resIndexF + 1;
				}

				if (!resFound) {
					int resLen = res.items.length;

					if (resLen + 1 < 0) {
						RuntimeException.NegativeArraySizeException = true;
						return;
					}
					int[] newList = new int[resLen + 1];
					pure_void();
					res.items = newList;
				}
			}
			index = pure_int(); //			index = index + 1;
		}
	}
	/*@ assignable \strictly_nothing; @*/
	native boolean /*@ helper @*/ pure_boolean();
	/*@ assignable \strictly_nothing; @*/
	native int /*@ helper @*/ pure_int();
	/*@ assignable \strictly_nothing; @*/
	native void /*@ helper @*/ pure_void();
}
