package abstraction.prime.NegativeArraySizeException;

import abstraction.RuntimeException;

class Prime {
	int size;
	/*@ nullable @*/ int[] a;

	/*@ requires !RuntimeException.NegativeArraySizeException;
	  @ ensures !RuntimeException.NegativeArraySizeException;
	  @ diverges true;
	  @ assignable \everything;
	 */
	void wrapper(int x, int y) {
		computePrimeInRange(x, y);
	}

	void computePrimeInRange(int x, int y) {
		size = 0;
		// loop through the numbers one by one
		int i = x;
                /*@
                loop_invariant (x <= i && i <= y) || (i == x && size == 0);                              
                assignable i, size;
                @*/
		while (i < y) {
			boolean isPrimeNumber = true;
			// check to see if the number is prime
			int j = 2;
                        /*@
                        loop_invariant true;
                        assignable j, isPrimeNumber;
                        @*/
			while (j < i) {
				if (i % j == 0) {
					isPrimeNumber = false;
					break; // exit the inner for loop
				}
				j = j + 1;
			}
			if (isPrimeNumber) {
				size = size + 1;
			}
			i = i + 1;
		}
		if (size>0){
			if (y-x < 0) {
				RuntimeException.NegativeArraySizeException = true;
				return;
			}
			this.a = new int[y-x];
		}
	}
}
