package abstraction.list.ArrayIndexOutOfBoundsException;

import abstraction.RuntimeException;

final class List {

	/*@ nullable @*/ int[] list;

	/*@ requires !RuntimeException.NullPointerException;
	  @ requires !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ requires !RuntimeException.NegativeArraySizeException;
	  @ requires a!=null && a.length >= 0;
	  @ ensures !RuntimeException.ArrayIndexOutOfBoundsException;
	  @ diverges true;
	  @ assignable \everything;
	  @*/
	void wrapper(/*@ nullable */int[] a) {
		removeDup(a);
	}
	
	void removeDup(/*@ nullable */int[] a) {
		int[] result = new int[a.length];

		int p = 0;
		int len = a.length;
		int k = 0;

		/*@ 
		  @ maintaining k>=0 && k<=a.length;
		  @ maintaining p>=0 && p<=k;
		  @ assignable result[*];
		  @*/
		while (k < len) {
			if (k < 0 || k >= len) {
				RuntimeException.ArrayIndexOutOfBoundsException = true;
				return;
			}
			boolean contains = false;
			int i = 0;
			/*@ 
			  @ maintaining i>=0 && i<=p;
			  @ assignable \strictly_nothing;
			  @*/
			while (i < p) {
				if (i < 0 || i >= result.length) {
					RuntimeException.ArrayIndexOutOfBoundsException = true;
					return;
				}
				if (result[i] == a[k]) {
					contains = true;
					break;
				}
				i = i + 1;
			}

			if (!contains) {
				if (p < 0 || p >= result.length) {
					RuntimeException.ArrayIndexOutOfBoundsException = true;
					return;
				}
				result[p] = a[k];
				p = p + 1;
			}
			k = k + 1;
		}

		int[] re = new int[p];
		int t = 0;
		/*@
		  @ maintaining t>=0 && t<=result.length;
		  @ maintaining t>=0 && t<=re.length;
		  @ assignable re[*];
		  @*/
		while (t < p) {
			if (t < 0 || t >= result.length) {
				RuntimeException.ArrayIndexOutOfBoundsException = true;
				return;
			}
			if (t < 0 || t >= re.length) {
				RuntimeException.ArrayIndexOutOfBoundsException = true;
				return;
			}
			re[t] = result[t];
			t = t + 1;
		}
		list = re;

	}
}
